import csv

books = ('',
    'Genesis', 'Exodus', 'Leviticus', 'Numbers', 'Deuteronomy', 'Joshua',
    'Judges', 'Ruth', '1 Samuel', '2 Samuel', '1 Kings', '2 Kings',
    '1 Chronicles', '2 Chronicles', 'Ezra', 'Nehemiah', 'Tobit', 'Judith',
    'Esther', '1 Maccabees', '2 Maccabees', 'Job', 'Psalm', 'Proverbs',
    'Ecclesiastes', 'Song of Solomon', 'Wisdom', 'Sirach', 'Isaiah',
    'Jeremiah', 'Lamentations', 'Baruch', 'Ezekiel', 'Daniel', 'Hosea', 'Joel',
    'Amos', 'Obadiah', 'Jonah', 'Micah', 'Nahum', 'Habakkuk', 'Zephaniah',
    'Haggai', 'Zechariah', 'Malachi',
    'Matthew', 'Mark', 'Luke', 'John',
    'Acts', 'Romans', '1 Corinthians', '2 Corinthians', 'Galatians',
    'Ephesians', 'Philippians', 'Colossians', '1 Thessalonians',
    '2 Thessalonians', '1 Timothy', '2 Timothy', 'Titus', 'Philemon',
    'Hebrews', 'James', '1 Peter', '2 Peter', '1 John', '2 John, 3 John', '',
    'Jude', 'Revelation'
)
book_ids = dict()
for i, book in enumerate(books):
    if book not in book_ids:
        book_ids[book] = i

print('STRINGTABLE ID BookStrings ""')
for book in books:
    print('  "{} "'.format(book))


book_data = []
chapter_data = []
period_string_ids = dict()
next_id = 0
def _string_id(s):
    global next_id
    if s in period_string_ids:
        return period_string_ids[s]
    period_string_ids[s] = next_id
    next_id += 1
    return next_id-1
with open('data/biy.csv') as f:
    for row in csv.reader(f):
        book_data.append((_string_id(row[0]),
                book_ids[row[1]], book_ids[row[3]], book_ids[row[5]]))
        chapter_data.append((row[2], row[4], row[6]))

print()
print('STRINGTABLE ID PeriodStrings ""')
for _, s in sorted(zip(period_string_ids.values(), period_string_ids.keys())):
    print('  "{}"'.format(s))

print()
print('HEX "tSTR" ID BookData')
for row in book_data:
    print('  0x{:02x} 0x{:02x} 0x{:02x} 0x{:02x}'.format(*row))

print()
print('STRINGTABLE ID Chapter1Data ""')
for row in chapter_data:
    print('  "{}"'.format(row[0]))

print()
print('STRINGTABLE ID Chapter2Data ""')
for row in chapter_data:
    print('  "{}"'.format(row[1]))

print()
print('STRINGTABLE ID Chapter3Data ""')
for row in chapter_data:
    print('  "{}"'.format(row[2]))
